'-- ICANSPEAK: example of speech synthesis (voice must be installed)
'demonstrates the use of COMencoding to handle foreign characters
'uses interface ISpeechVoice from SAPI.DLL

$typecheck on
$equalprec on
$include "genericcom.inc"
declare sub setchinesevoice(chvoice as INTERFACE)

dim voice as INTERFACE
voice.CreateObject("SAPI.SpVoice.1") 'SpVoice
setchinesevoice(voice)

COMencoding=936 'From here on, strings passed to Invoke will be encoded in Chinese GB

defint x = voice.getnum ("Speak", "Ƿˡ", 0)


'look for a chinese voice and use it with the 'chvoice' interface
sub setchinesevoice
dim voices as INTERFACE, v2 as INTERFACE
defint i
defstr s$
if chvoice.pointer=0 then exit sub
voices.pointer=chvoice.getnum ("GetVoices","LANGUAGE=804",void) 'look for voices that support &h804=Chinese
defint vcount=voices.getnum("Count")
'if vcount=0 then showmessage "Sorry, couldn't find a Chinese voice on this computer." : exit sub
for i=0 to vcount-2
    v2.pointer=voices.getnum("Item",i)
    s$ = v2.getstr ("GetDescription",void) : s$=lcase$(s$)
    if instr(s$,"microsoft")=0 then exit for 'use non-Microsoft voices if one is available, the Microsoft Chinese voice is not so good
next
defint vp=voices.getnum("Item",i)  'get voice pointer
chvoice.invoke("setbyref_Voice", vp) 'set that voice
chvoice.invoke ("set_Rate", -4)  'slow it down a bit (values are from -10=very slow to +10=very fast)
end sub
